GlueGen: com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo Class Reference

GlueGen v2.6.0-rc-20250822 GlueGen, Native Binding Generator for Java™ (public API).

Public Member Functions | Protected Member Functions | List of all members
com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo Class Reference
Inheritance diagram for com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo:
Collaboration diagram for com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo:

## Public Member Functions

final boolean | shallLinkGlobal ()
final boolean | shallLookupGlobal ()

If method returns `true` and if a `SecurityManager` is installed, user needs link permissions for all libraries, i.e.for `new RuntimePermission("loadLibrary.*");`!

Returns
  true if the dynamic symbol lookup shall happen system wide, over all loaded libraries. Otherwise only the loaded native libraries are used for lookup, which shall be the default.

More...

final List< String > | getGlueLibNames ()
| If a `SecurityManager` is installed, user needs link permissions for the named libraries. More...
final boolean | searchToolLibInSystemPath ()
| Returns `true` if tool libraries shall be searched in the system path (default), otherwise `false`. More...
final boolean | searchToolLibSystemPathFirst ()
| Returns `true` if system path shall be searched first (default), rather than searching it last. More...
final List< List< String > > | getToolLibNames ()
| If a `SecurityManager` is installed, user needs link permissions for the named libraries. More...
List< String > | getSymbolForToolLibPath ()
| Returns optional list of optional symbol names per `getToolLibNames()` in same order for an OS which requires the symbol's address to retrieve the path of the containing library. More...
final List< String > | getToolGetProcAddressFuncNameList ()
| May return the native libraries. More...
final long | toolGetProcAddress (final long toolGetProcAddressHandle, final String funcName)
| May implement the lookup function using the Tools facility. More...
final boolean | useToolGetProcAdressFirst (final String funcName)
final RunnableExecutor | getLibLoaderExecutor ()
| Returns a suitable `RunnableExecutor` implementation, which is being used to load the `tool` and `glue` native libraries. More...
boolean | searchToolLibInSystemPath ()
| Returns `true` if tool libraries shall be searched in the system path (default), otherwise `false`. More...
boolean | searchToolLibSystemPathFirst ()
| Returns `true` if system path shall be searched first (default), rather than searching it last. More...
List< List< String > > | getToolLibNames ()
| If a `SecurityManager` is installed, user needs link permissions for the named libraries. More...
List< String > | getSymbolForToolLibPath ()
| Returns optional list of optional symbol names per `getToolLibNames()` in same order for an OS which requires the symbol's address to retrieve the path of the containing library. More...
List< String > | getGlueLibNames ()
| If a `SecurityManager` is installed, user needs link permissions for the named libraries. More...
List< String > | getToolGetProcAddressFuncNameList ()
| May return the native libraries. More...
long | toolGetProcAddress (long toolGetProcAddressHandle, String funcName)
| May implement the lookup function using the Tools facility. More...
boolean | useToolGetProcAdressFirst (String funcName)
boolean | shallLinkGlobal ()
boolean | shallLookupGlobal ()
| If method returns `true` and if a `SecurityManager` is installed, user needs link permissions for all libraries, i.e. More...
RunnableExecutor | getLibLoaderExecutor ()
| Returns a suitable `RunnableExecutor` implementation, which is being used to load the `tool` and `glue` native libraries. More...

## Protected Member Functions

| Test1DynLibBundleInfo ()

## Additional Inherited Members

Static Public Attributes inherited from com.jogamp.common.os.DynamicLibraryBundleInfo
static final boolean | DEBUG = DynamicLibraryBundle.DEBUG

## Detailed Description

Definition at line 213 of file Test1p2DynamicLibraryBundle.java.

## Constructor & Destructor Documentation

## ◆ Test1DynLibBundleInfo()

com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.Test1DynLibBundleInfo | ( |  | ) |

protected

Definition at line 220 of file Test1p2DynamicLibraryBundle.java.

## Member Function Documentation

## ◆ getGlueLibNames()

final List< String > com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.getGlueLibNames | ( |  | ) |

If a `SecurityManager` is installed, user needs link permissions for the named libraries.

Returns
  a list of Glue library names.
  - GL: [ "nativewindow_x11", "jogl_gl2es12", "jogl_desktop" ]
  - NEWT: [ "nativewindow_x11", "newt" ]
  - Cg: [ "nativewindow_x11", "jogl_cg" ]
  Only the last entry is crucial, ie all other are optional preload dependencies and may generate errors, which are ignored.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 242 of file Test1p2DynamicLibraryBundle.java.

## ◆ getLibLoaderExecutor()

final RunnableExecutor com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.getLibLoaderExecutor | ( |  | ) |

Returns a suitable `RunnableExecutor` implementation, which is being used to load the `tool` and `glue` native libraries.

This allows the generic `DynamicLibraryBundle` implementation to load the native libraries on a designated thread.

An implementation may return `DynamicLibraryBundle#getDefaultRunnableExecutor()`.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 290 of file Test1p2DynamicLibraryBundle.java.

Here is the call graph for this function:

## ◆ getSymbolForToolLibPath()

List< String > com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.getSymbolForToolLibPath | ( |  | ) |

Returns optional list of optional symbol names per `getToolLibNames()` in same order for an OS which requires the symbol's address to retrieve the path of the containing library.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 272 of file Test1p2DynamicLibraryBundle.java.

## ◆ getToolGetProcAddressFuncNameList()

final List< String > com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.getToolGetProcAddressFuncNameList | ( |  | ) |

May return the native libraries.

    GetProcAddressFunc

names, the first found function is being used.
This could be eg:

     glXGetProcAddressARB, glXGetProcAddressARB

.
If your Tool does not has this facility, just return null.

See also
  toolGetProcAddress(long, String)

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 275 of file Test1p2DynamicLibraryBundle.java.

## ◆ getToolLibNames()

final List< List< String > > com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.getToolLibNames | ( |  | ) |

If a `SecurityManager` is installed, user needs link permissions for the named libraries.

Returns
  a list of Tool library names or alternative library name lists.
  - GL/GLU example Unix: [ [ "libGL.so.1", "libGL.so", "GL" ], [ "libGLU.so", "GLU" ] ]
  - GL/GLU example Windows: [ "OpenGL32", "GLU32" ]
  - Cg/CgGL example: [ [ "libCg.so", "Cg" ], [ "libCgGL.so", "CgGL" ] ]

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 257 of file Test1p2DynamicLibraryBundle.java.

## ◆ searchToolLibInSystemPath()

final boolean com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.searchToolLibInSystemPath | ( |  | ) |

Returns `true` if tool libraries shall be searched in the system path (default), otherwise `false`.

Since
  2.4.0

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 247 of file Test1p2DynamicLibraryBundle.java.

## ◆ searchToolLibSystemPathFirst()

final boolean com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.searchToolLibSystemPathFirst | ( |  | ) |

Returns `true` if system path shall be searched first (default), rather than searching it last.

If `searchToolLibInSystemPath()` is `false` the return value is ignored.

Since
  2.4.0

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 252 of file Test1p2DynamicLibraryBundle.java.

## ◆ shallLinkGlobal()

final boolean com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.shallLinkGlobal | ( |  | ) |

Returns `true`, since we might load the library and allow symbol access to subsequent libs.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 230 of file Test1p2DynamicLibraryBundle.java.

## ◆ shallLookupGlobal()

final boolean com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.shallLookupGlobal | ( |  | ) |

If method returns `true` and if a `SecurityManager` is installed, user needs link permissions for all libraries, i.e.for `new RuntimePermission("loadLibrary.*");`!

Returns
  true if the dynamic symbol lookup shall happen system wide, over all loaded libraries. Otherwise only the loaded native libraries are used for lookup, which shall be the default.

Returns `false`.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 239 of file Test1p2DynamicLibraryBundle.java.

## ◆ toolGetProcAddress()

final long com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.toolGetProcAddress | ( | final long | toolGetProcAddressHandle,
|  | final String | funcName
| ) |  |

May implement the lookup function using the Tools facility.

The actual function pointer is provided to allow proper bootstrapping of the ProcAddressTable, using one of the provided function names by `getToolGetProcAddressFuncNameList()`.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 280 of file Test1p2DynamicLibraryBundle.java.

## ◆ useToolGetProcAdressFirst()

final boolean com.jogamp.gluegen.test.junit.generation.Test1p2DynamicLibraryBundle.Test1DynLibBundleInfo.useToolGetProcAdressFirst | ( | final String | funcName | ) |

Parameters

  funcName |

Returns
  true if `toolGetProcAddress(long, String)` shall be tried before the system loader for the given function lookup. Otherwise false. Default is true.

Implements com.jogamp.common.os.DynamicLibraryBundleInfo.

Definition at line 285 of file Test1p2DynamicLibraryBundle.java.

The documentation for this class was generated from the following file:

- src/junit/com/jogamp/gluegen/test/junit/generation/Test1p2DynamicLibraryBundle.java